/*
** some lowlevel routines that are also in my library.
**  this file contains the C versions for those who don't
**  have access to my library
*/

#include "ar.h"
#include <stdio.h>
#include <ctype.h>

/*
** get file stats using _os9 for portability
*/

get_fstat(pn, fs)
int      pn;
FILDES   *fs;
   {
   _gs_gfd(pn, fs, sizeof(FILDES));
   }


/*
** set file attributes
*/

set_fstat(pn, fs)
int      pn;
FILDES   *fs;
   {
   _ss_pfd(pn, fs, sizeof(FILDES));
   _ss_attr(pn, fs->fd_attr);
   }
/*page*/
/*
** get the file size
*/

long get_fsize(pn)
int   pn;
   {
   long  size;

   size = _gs_size(pn);
   return (size);
   }


/*
** change the file size
*/

set_fsize(pn, size)
int   pn;
long  size;
   {
   _ss_size(pn, size);
   }


/*
**  convert a long read from disk as an array of char
**   back to a long.
*/

long c4tol(s)
char  *s;
   {
   long  x = 0;

   x = (x + (*s++ &0xff)) << 8;
   x = (x + (*s++ &0xff)) << 8;
   x = (x + (*s++ &0xff)) << 8;
   x = (x + (*s &0xff));
   return (x);
   }
/*page*/

/*
**      Returns true if string s matches pattern p.
*/

#ifdef OSK
patmatch(p, s, f)
char           *p;                                       /* pattern */
register char  *s;                               /* string to match */
char           f;                            /* flag for case force */
   {
   char  pc;                     /* a single character from pattern */

   while (pc = (f ? toupper(*p++) : *p++))
      {
      if (pc == '*')
         {
         do {                    /* look for match till s exhausted */
            if (patmatch (p, s, f))
                  return (1);
            } while (*s++);
         return (0);
         }
      else
         if (*s == 0)
            return (0);                       /* s exhausted, p not */
         else
            if (pc == '?')
               s++;                       /* matches all, just bump */
            else
               if (pc != (f ? toupper(*s++) : *s++))
                  return (0);
      }
   return (!*s);            /* p exhausted, ret true if s exhausted */
   }
#endif


/*
** initialize memory (variables) of string type
*/

setmem(p, q, v)
char  *p;                                                 /* string */
int   q;                                                   /* count */
char  v;                                                   /* value */
   {
   while (q--)
      *p++ = v;
   }


#ifdef OSK
/*
** special strcmp to ignore case
*/

strucmp(s1, s2)
char          *s1;
register char *s2;
   {
   while (toupper(*s1) == toupper(*s2))
      {
      if (*s2++ == 0)
            return (0);
      s1++;
      }
   return (toupper(*s1) - toupper(*s2));
   }
#endif
